/** 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; either version 2 of the License, or 
 * (at your option) any later version. 
 *  
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details. 
 *  
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA 
 * 
 * @version 2.0
 * DisChoco
 * Edge.java
 */ 
package gui.visualizing;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;

/**
 * 
 * 
 * @authors 
 * <a href="mailto:ezzahir@ensa-agadir.ac.ma?subject=DisChoco &cc=wahbi@lirmm.fr &cc=bessiere@lirmm.fr">
 * Redoaune Ezzahir</a> and 
 * <a href="mailto:wahbi@lirmm.fr?subject=DisChoco &cc=ezzahir@ensa-agadir.ac.ma &cc=bessiere@lirmm.fr">
 * Mohamed Wahbi</a>
 * 
 */
public class Edge {
	private static final long serialVersionUID = 2659634710394008151L;
	Vertex source;
	Vertex target;
	int weight;
	public boolean selected = false;
	java.awt.geom.Line2D.Double shape = null;

	public Edge(Vertex from, Vertex to) {
		this.source = from;
		this.target = to;
	}

	public Edge(Vertex from, Vertex to, int weight) {
		this(from, to);
		this.weight = weight;
	}

	public void draw(Graphics g) {
		Graphics2D gr = (Graphics2D) g;
		gr.setStroke(new BasicStroke(1.5f));
		if (selected) gr.setColor(Color.orange);
		else gr.setColor(Color.black);
		shape = new java.awt.geom.Line2D.Double(source.getCenter(), target.getCenter());
		gr.draw(shape);
		gr.setStroke(new BasicStroke(1.8f));
//		gr.dispose();
	}
	public boolean contains(Point p) {
		return shape.contains(p);
	}
}
