package kernel.order;

import java.util.Arrays;
import java.util.HashMap;
import java.util.Iterator;

import util.IntArray;

/**
 * A class to construct the Lexicographic order
 * 
 * @author Redouane EZZAHIR
 * 
 */
public class LexicographicAO extends CentralizedAO implements ChainOrder {

	public LexicographicAO() {
		super();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see order.CentralizedAgentOrdering#buildAgentsOrder()
	 */
	public IntArray buildAgentsOrder() {
		IntArray order = new IntArray();
		int n = this.agentsComplexity.keySet().size();
		for (int i = 1 ; i <= n ; i++) {
			order.add(i);
		}
		return order;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see order.CentralizedAgentOrdering#buildAgentsOrder()
	 */
	public static IntArray buildpriorityTree(HashMap<Integer, AgentComplexity> complexities) {
		int[] agentIds = new int[complexities.size()];
		Iterator<Integer> it = complexities.keySet().iterator();
		int i = 0;
		while (it.hasNext()) {
			agentIds[i++] = it.next();
		}
		Arrays.sort(agentIds);
		return new IntArray(agentIds);
	}

}
