package simple.dcsp.abtfamily.abt;

import kernel.AbstractAgent;
import kernel.StopException;
import kernel.com.Message;
import kernel.com.MessageHandler;
import kernel.vars.integer.explain.ExplainedIntVar;
import simple.SingleExplainedVarAgent;
import simple.dcsp.abtfamily.ABT;
import util.Commands;
import util.VarAssignment;

public class AddLinkMsgHandler extends MessageHandler {

	public AddLinkMsgHandler(AbstractAgent agent) {
		super(agent, Commands.ADDLINK);
	}

	/**
	 * @param msg
	 */
	public void processMessage(Message msg) throws StopException {
		int senderId = msg.getSenderId();
		this.myAgent.communicator.addNeighbor(senderId);
		ExplainedIntVar v = ((SingleExplainedVarAgent) this.myAgent).getMyVar();
		VarAssignment Ass = (VarAssignment) msg.get(Commands.LINK);
		if (!Ass.equals(v.getVarAssignment())) {/* re-send OK message */
			((ABT) this.myAgent).sendOkMessage(senderId);
		}
	}

	/**
	 * @param ass
	 */
	public void sendAddLink(VarAssignment ass) {
		Message msg = this.createMessage();
		msg.addContents(Commands.LINK, ass);
		msg.setReceiverId(ass.getAgentId());
		((ABTAgent) this.myAgent).storeStatisticsFor(msg);
		this.myAgent.sendMessage(msg);
	}

}
