/*************************************************************************

 **************************************************************************/
package simple.dcsp.abtfamily.abtdo;

import kernel.AbstractAgent;
import kernel.AbstractMaster;
import kernel.StopException;
import kernel.com.Message;
import kernel.com.MessageHandler;
import util.Commands;
import util.IntArray;

public class OrderMsgHandler extends MessageHandler {

	public OrderMsgHandler(AbstractAgent agent) {
		super(agent, Commands.ORDER);
	}

	/**
	 * @param msg
	 */
	public void processMessage(Message msg) throws StopException {
		int senderId = msg.getSenderId();
		int domainSize = (Integer) msg.get(Commands.DomainSize);
		CurrentOrder currentOrder = (CurrentOrder) msg.get(Commands.ORDER);
		if (((ABTDOAgent) this.myAgent).setCurrentOrder(currentOrder)) {
			((ABTDOAgent) this.myAgent).setDomainSize(senderId, domainSize);
			((ABTDOAgent) this.myAgent).CheckAgentView();
		}
	}

	public void sendOrderMessages() {
		IntArray lowerAgents = this.myAgent.agentOrder.getLowerAgents();
		for (int lower : lowerAgents) {
			this.sendOrderMessage(lower);
		}
		this.sendOrderMessage(AbstractMaster.MasterId);
	}

	public void sendOrderMessage(int agId) {
		int dom = ((ABTDOAgent) this.myAgent).getMyVar().getDomainSize();
		CurrentOrder currentOrder = ((ABTDOAgent) this.myAgent).getCurrentOrder();
		Message msg = createMessage();
		msg.addContents(Commands.DomainSize, dom);
		msg.addContents(Commands.ORDER, currentOrder);
		msg.setReceiverId(agId);
		((ABTDOAgent) this.myAgent).storeStatisticsFor(msg);
		this.myAgent.sendMessage(msg);
	}
}
