package simple.dcsp.afcfamily.afcng.triggerednogood;

import kernel.StopException;
import simple.Nogood;
import simple.dcsp.afcfamily.afcng.DynamicAFCngAgent;
import simple.dcsp.afcfamily.afcng.TimeStamp;
import util.Commands;
import util.Instantiation;

public class AFCngTriggeredNogoodAgent extends DynamicAFCngAgent {

	protected int nogoodGenerator = -1;

//	public static final int DEG = 1;
//	public static final int FUTUR_DEG = 2;
//	public static final int PAST_DEG = 3;
//	protected int heuristic = DEG; // static or dynamic heuristic

	public AFCngTriggeredNogoodAgent(int agentId, String agName, String description) {
		super(agentId, agName, description);
	}

	// ========================================================================
	@Override
	public int getNextAgent() {
		if (this.nogoodGenerator != -1 && this.agentOrder.isLower(this.nogoodGenerator)){
			return this.nogoodGenerator;
		}
		return super.getNextAgent();
//		int max = this.getMaxDegAgent();
//		int next = super.getNextAgent();
//		if(max!=next){
//			System.out.println("max="+max+" next="+next+"\n"+this.agentView+"\n"+
//					this.agentOrder+"\n"+this.agentOrder.getAgentsGraph());
//			System.exit(0);
//		}
//		return max;
	}

//	/**
//	 * @return
//	 */
//	private int getMaxDegAgent() {
//		IntArray futureAgents = this.agentOrder.getLowerAgents();
//		int deg = Integer.MIN_VALUE;
//		int nextAgent = -1;
//		for(int agId : futureAgents){
//			int agDeg = this.getDeg(agId, futureAgents);
//			if (agDeg > deg) {
//				deg = agDeg;
//				nextAgent = agId;
//			}
//		}
//		return nextAgent;
//	}
//	
//	/**
//	 * 
//	 * @param agId
//	 * @param unassigned
//	 * @return
//	 */
//	private int getDeg(int agId, IntArray unassigned) {
//		if (heuristic == DEG) {
//			return this.agentOrder.getAgentsGraph().degree(agId);
//		} else if (heuristic == FUTUR_DEG) {
//			int future_deg = 0;
//			for( int neigh : this.agentOrder.getNeighborsOf(agId)){
//				if (unassigned.contains(neigh))
//					future_deg++;
//			}
//			return future_deg;
//		} else {
//			int past_deg = 0;
//			IntArray assigned = this.getOrder().minus(unassigned);
//			Iterable<Integer> neighbors = this.agentOrder.getNeighborsOf(agId);
//			for (int neigh : neighbors){
//				if (assigned.contains(neigh))
//					past_deg++;
//			}
//			return past_deg;
//		}
//	}

	// ==========================================================================
//	@Override
	public void processNogood(Nogood nogood, TimeStamp timeStamp, Instantiation cpa, int generator) throws StopException {
		int cmp = this.timeStamp.compareTimeStamp(timeStamp);
		if (cmp > 0) {
			this.updateOrdering(cpa, timeStamp);
		}
		if (cmp >= 0) {
			if(this.agentViewConsistent && this.isCoherent(nogood)){
				this.nogoodGenerator = generator;
				this.makeNoGoodConstraint(nogood);
				this.assignCPA();
			} else{
				this.auxiliaryStatistics.get(Commands.nbObsoleteNogood).value++;
			}
		}
	}
	/**
	 * 
	 */
	@Override
	public void sendCPA(Instantiation cpa) throws StopException {
		super.sendCPA(cpa);
		this.nogoodGenerator = -1;
	}

}