package simple.dcsp.sbt;

import java.util.ArrayList;
import java.util.Collection;

import kernel.AbstractAgent;
import kernel.AbstractMaster;
import kernel.order.LexicographicAO;
import util.Commands;

public class SBTMaster extends AbstractMaster {

	public SBTMaster() {
		this.setCentralizedAO(new LexicographicAO());
	}

	@Override
	public AbstractAgent makeAgent(int agentId, String agentName, String description) {

		return new SBTAgent(agentId, agentName, description);
	}


	/* (non-Javadoc)
	 * @see kernel.AbstractMaster#getTypesOfMessages()
	 */
	@Override
	public Collection<String> getTypesOfMessages() {
		Collection<String> ans = new ArrayList<String>();
		ans.add(Commands.CPA);
		ans.add(Commands.BACKTRACK);
		ans.add(Commands.TERMINATION_DETETION);
		return ans;
	}

}
