package util.parser;

import kernel.AbstractAgent;
import kernel.VarIdentifier;
import kernel.vars.integer.IntExternalVar;
import kernel.vars.integer.IntVariable;
import simple.SimpleAgent;

public class PVariable implements Comparable<Object> {
	private PAgent agent;
	private String name;
	private int id;
	private String description;
	private PDomain domain;
	private IntVariable var = null;

	public PAgent getAgent() {
		return this.agent;
	}

	public void setAgent(PAgent agent) {
		this.agent = agent;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getDescription() {
		return this.description;
	}

	public int getId() {
		return this.id;
	}

	public int getAgentId() {
		return this.agent.getId();
	}

	public PDomain getDomain() {
		return domain;
	}

	public void setDomain(PDomain dom) {
		domain = dom;
	}

	/**
	 * 
	 * @param agent
	 * @param name
	 * @param id
	 * @param description
	 * @param domain
	 */
	public PVariable(PAgent agent, String name, int id, String description, PDomain domain) {
		this.agent = agent;
		this.name = name;
		this.id = id;
		this.description = description;
		this.domain = domain;

	}

	public IntExternalVar toIntExternalVar(AbstractAgent agent) {
		int vId = this.getId();
		int agId = this.getAgent().getId();
		VarIdentifier extVarId = new VarIdentifier(agId, vId);
		int vals[] = this.domain.getValues();
		return agent.makeExternalVar(extVarId, vals);
	}

	public String toString() {
		return "<variable name=\"" + this.name + "\" id=\"" + this.id + "\" domain=\"" + this.domain.getName() + "\" description=\""
				+ this.description + "\" agent=\"" + this.agent.getName() + "\"/>\n";
	}

	public int compareTo(Object o) {
		PVariable v = (PVariable) o;
		return this.id - v.id;
	}

	public IntVariable makeIntVariable(SimpleAgent agent) {
		int vals[] = this.getDomain().getValues();
		this.var = agent.makeInternalVar(vals);
		return this.var;
	}

	public IntVariable getDisChocoVar() {
		return var;
	}

	public void setId(int i) {
		this.id = i;
	}

}
